/******************************************************************************/

extern double carriesObject(Object *carrier, double meetsRestriction(Object *o));
extern double containsObject(Object *container, double meetsRestriction(Object *o));

/******************************************************************************/

extern GoalType goalTrue(ContentionScheduler *cs);
extern GoalType goalFalse(ContentionScheduler *cs);
extern GoalType goalHandsEmpty(ContentionScheduler *cs);
extern GoalType goalHold(ContentionScheduler *cs, double meetsRestriction(Object *o));
extern GoalType goalOnTable(ContentionScheduler *cs, double meetsRestriction(Object *o));
extern GoalType goalFixated(ContentionScheduler *cs, double meetsRestriction(Object *o));

/******************************************************************************/

extern double schemaFixateSourceTriggersSource(ContentionScheduler *cs, Object *o);
extern double schemaFixateSourceTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaFixateTargetTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaFixateTargetTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaFixateImplementTriggersImplement(ContentionScheduler *cs, Object *o);
extern double schemaFixateImplementTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaFixateThemeTriggersTheme(ContentionScheduler *cs, Object *o);
extern double schemaFixateThemeTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaPickUpTriggersSource(ContentionScheduler *cs, Object *o);
extern double schemaPickUpTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaPickUpTriggersTheme(ContentionScheduler *cs, Object *o);
extern double schemaPickUpTriggersImplement(ContentionScheduler *cs, Object *o);
extern double schemaPickUpTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaPutDownTriggersSource(ContentionScheduler *cs, Object *o);
extern double schemaPutDownTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaPutDownTriggersTheme(ContentionScheduler *cs, Object *o);
extern double schemaPutDownTriggersImplement(ContentionScheduler *cs, Object *o);
extern double schemaPutDownTriggersEffector(ContentionScheduler *cs, Effector *e);

/*----------------------------------------------------------------------------*/

extern double schemaPickUpSourceTriggersSource(ContentionScheduler *cs, Object *o);
extern double schemaPickUpSourceTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaPickUpTargetTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaPickUpTargetTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaPickUpImplementTriggersImplement(ContentionScheduler *cs, Object *o);
extern double schemaPickUpImplementTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaPickUpThemeTriggersTheme(ContentionScheduler *cs, Object *o);
extern double schemaPickUpThemeTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaPutDownSourceTriggersSource(ContentionScheduler *cs, Object *o);
extern double schemaPutDownSourceTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaPutDownTargetTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaPutDownTargetTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaPutDownImplementTriggersImplement(ContentionScheduler *cs, Object *o);
extern double schemaPutDownImplementTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaPutDownThemeTriggersTheme(ContentionScheduler *cs, Object *o);
extern double schemaPutDownThemeTriggersEffector(ContentionScheduler *cs, Effector *e);

/******************************************************************************/
