/*******************************************************************************

    FILE: juice/triggers.c
    AUTHOR: R. Cooper
    CREATION DATE: Fri Jul 30 14:03:24 2004
    CONTENTS: Schema triggering functions for the juice task

*******************************************************************************/

#include "../cs.h"
#include "task.h"

/******************************************************************************/

extern double holds(Effector *e, double f(Object *object));

/******************************************************************************/

double schemaCutThemeTriggersTheme(ContentionScheduler *cs, Object *object)
{
    return(isOrange(object));
}

double schemaCutThemeTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(restAct);
}

double schemaSqueezeWithImplementTriggersImplement(ContentionScheduler *cs, Object *object)
{
    return(isJuicer(object));
}

double schemaSqueezeWithImplementTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(restAct);
}

double schemaPourAllIntoTargetTriggersTarget(ContentionScheduler *cs, Object *object)
{
    return(FZOR(isJuiceGlass(object), isTable(object)));
}

double schemaPourAllIntoTargetTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(restAct);
}

double schemaBounceOnTargetTriggersTarget(ContentionScheduler *cs, Object *object)
{
    return(isTable(object));
}

double schemaBounceOnTargetTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(restAct);
}

/******************************************************************************/
