#include "../cs.h"
#include "task.h"

extern double holds(Effector *e, double f(Object *o));

/******************************************************************************/

double schemaPrepareLetterTriggersTarget(ContentionScheduler *cs, Object *object)
{
    return(0);
//    return(isEnvelope(object));
}

double schemaPrepareLetterTriggersTheme(ContentionScheduler *cs, Object *object)
{
    return(0);
//    return(FZOR(isStamp(object), isLetter(object)));
}

double schemaPrepareLetterTriggersImplement(ContentionScheduler *cs, Object *object)
{
    return(0);
//    return(isPen(object));
}

/*----------------------------------------------------------------------------*/

double schemaAddressEnvelopeTriggersTarget(ContentionScheduler *cs, Object *object)
{
    return(isEnvelopeFront(object));
}

double schemaAddressEnvelopeTriggersImplement(ContentionScheduler *cs, Object *object)
{
    return(isPenNib(object));
}

/*----------------------------------------------------------------------------*/

double schemaApplyStampTriggersTarget(ContentionScheduler *cs, Object *object)
{
    return(isEnvelopeFront(object));
}

double schemaApplyStampTriggersTheme(ContentionScheduler *cs, Object *object)
{
    return(isStampBack(object));
}

/*----------------------------------------------------------------------------*/

double schemaInsertLetterTriggersTarget(ContentionScheduler *cs, Object *object)
{
    return(isEnvelope(object));
}

double schemaInsertLetterTriggersTheme(ContentionScheduler *cs, Object *object)
{
    return(isLetter(object));
}

/*----------------------------------------------------------------------------*/

/* Lowest level: -------------------------------------------------------------*/

double schemaPlaceStampTriggersTheme(ContentionScheduler *cs, Object *object)
{
    return(FZAND(isStamp(object), isHeld(object)));
}

double schemaPlaceStampTriggersTarget(ContentionScheduler *cs, Object *object)
{
    return(isEnvelopeFront(object));
}

double schemaWriteAddressTriggersImplement(ContentionScheduler *cs, Object *object)
{
    return(FZAND(isPen(object), isHeld(object)));
}

double schemaWriteAddressTriggersTarget(ContentionScheduler *cs, Object *object)
{
    return(isEnvelopeFront(object));
}

double schemaPackEnvelopeTriggersTarget(ContentionScheduler *cs, Object *object)
{
    return(isUnsealedEnvelope(object));
}

double schemaPackEnvelopeTriggersTheme(ContentionScheduler *cs, Object *object)
{
    return(FZAND(isLetter(object), isHeld(object)));
}

double schemaSealItTriggersTarget(ContentionScheduler *cs, Object *object)
{
    return(isEnvelopeBack(object));
}

/******************************************************************************/

double schemaAddressEnvelopeTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(restAct);
}

double schemaPrepareLetterTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(restAct);
}

double schemaApplyStampTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(restAct);
}

double schemaInsertLetterTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(restAct);
}

/* Lowest level: -------------------------------------------------------------*/

double schemaPlaceStampTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(holds(e, isStamp));
}

double schemaWriteAddressTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(holds(e, isPen));
}

double schemaPackEnvelopeTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(FZOR(holds(e, isLetter), holds(e, isUnsealedEnvelope)));
}

double schemaSealItTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(FZOR(holds(e, isEnvelopeBack), isEmptyEffectorFuzzy(e)));
}

/******************************************************************************/

double schemaAddressTargetTriggersTarget(ContentionScheduler *cs, Object *o)
{
    return(isEnvelopeFront(o));
}

double schemaAddressTargetTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(holds(e, isPenNib));
}

/******************************************************************************/

double schemaStampTargetTriggersTarget(ContentionScheduler *cs, Object *o)
{
    return(isEnvelopeFront(o));
}

double schemaStampTargetTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(holds(e, isStamp));
}

/******************************************************************************/

double schemaLickAndSealTriggersTheme(ContentionScheduler *cs, Object *o)
{
    return(isEnvelopeBack(o));
}

double schemaLickAndSealTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(holds(e, isEnvelopeBack));
}

/******************************************************************************/

double schemaFoldLetterTriggersTheme(ContentionScheduler *cs, Object *object)
{
    return(isLetter(object));
}

double schemaFoldLetterTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(holds(e, isLetter));
}

/******************************************************************************/

double schemaFoldTriggersTheme(ContentionScheduler *cs, Object *object)
{
    return(isPaper(object));
}

double schemaFoldTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(holds(e, isPaper));
}

/******************************************************************************/

double schemaLickTriggersTheme(ContentionScheduler *cs, Object *object)
{
    return(isEnvelopeBackOrStampBack(object));
}

double schemaLickTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(holds(e, isEnvelopeBackOrStampBack));
}

/******************************************************************************/

double schemaSealEnvelopeTriggersTheme(ContentionScheduler *cs, Object *object)
{
    return(FZAND(isEnvelopeBack(object), FZNOT(isSealed(object))));
}

double schemaSealEnvelopeTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(holds(e, isEnvelopeBack));
}

/******************************************************************************/

double schemaTuckFlapTriggersTheme(ContentionScheduler *cs, Object *object)
{
    return(FZAND(isEnvelopeBack(object), FZNOT(isSealed(object))));
}

double schemaTuckFlapTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(holds(e, isEnvelopeBack));
}

/******************************************************************************/

double schemaTuckTriggersTheme(ContentionScheduler *cs, Object *object)
{
    return(FZAND(isEnvelopeBack(object), FZNOT(isSealed(object))));
}

double schemaTuckTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(holds(e, isEnvelopeBack));
}

/******************************************************************************/
