/*******************************************************************************

    FILE: espress_effector.c
    AUTHOR: R. Cooper
    CREATION DATE: Thu Apr 15 13:11:54 2004
    CONTENTS: 

*******************************************************************************/

#include "../cs.h"

/******************************************************************************/

void write_espresso_effector_attributes(FILE *fp, Effector *effector)
{
    ObjectList *os;

    if (effector->itemsHeld) {
	fprintf(fp, "holds");
	for (os = effector->itemsHeld; os; os = os->tail) {
	    if (os->tail) {
		fprintf(fp, " %s,", os->head->name);
	    }
	    else {
		fprintf(fp, " %s", os->head->name);
	    }
	}
    }
    else {
	fprintf(fp, "empty");
    }
}

/******************************************************************************/

void install_espresso_effectors(ContentionScheduler *cs)
{
    effectorInstall(cs, "leftHand");
    effectorInstall(cs, "rightHand");
}

/******************************************************************************/
